﻿using DSA.Models;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DSA.DBS_Klassen {
    public class Dbs_QueriesExceute {

        public const String TBL_GENDER = "DATA_GENDER";

        public const String TBL_EYECOLOR = "DATA_EYECOLOR";
        public const String TBL_HAIRCOLOR = "DATA_COLORHAIR";
        public const String TBL_BODYCOLOR = "DATA_BODYCOLOR";
        public const String TBL_EXPERIENCELEVEL = "DATA_EXPERIENCELEVEL";
        public const String TBL_SPECIES = "DATA_SPECIES";
        public const String TBL_SOCIALSTATE = "DATA_SOCIALSTATE";
        public const String TBL_CULTURE = "DATA_CULTURE";
        public const String TBL_PROFESSION = "DATA_PROFESSION";
        public const String TBL_TRADITION = "DATA_TRADITION";
        public const String TBL_FAITH = "DATA_FAITH";
        public const String TBL_ANIMALSOUL = "DATA_ANIMALSOUL";
        public const String TBL_ADVANTAGE = "DATA_ADVANTAGE";
        public const String TBL_DISADVANTAGE = "DATA_DISADVANTAGE";

        public const String TBL_BASICDATAS = "BASICDATAS";
        public const String TBL_BACKGROUND = "BACKGROUND";


        public static String getDatalist(String property) {
            return "SELECT Label FROM " + property;
        }


        public static List<ModelDatalist> getItemsFromDataList(String property) {
            List<ModelDatalist> liste = new List<ModelDatalist>();
            String sql = getDatalist(property);
            Dbs dbs = Dbs.getDbsInstance();
            DataTable dt = dbs.selectDBS(MyRegistry.Databasefile, sql);

            ModelDatalist datalist;
            foreach (System.Data.DataRow row in dt.Rows) {
                datalist = new ModelDatalist((String)row.ItemArray[0]);
                liste.Add(datalist);
            }
            return liste;
        }


        public static String getinsertDatalist(String property, ModelDatalist datalist) {
           return "INSERT INTO " + property + " (Label) " +
                  "Values (" + datalist.LabelQuote +
              ")";
        }

        public static void insertDatalist(String property, ModelDatalist datalist) {
            String sql = getinsertDatalist(property, datalist);
            Dbs dbs = Dbs.getDbsInstance();
            dbs.changeDBS(MyRegistry.Databasefile, sql);
        }

        public static void insertNewDatalist(String property, List<ModelDatalist> liste) {
            Dbs dbs = Dbs.getDbsInstance();
            OleDbConnection con = dbs.getCon(MyRegistry.Databasefile);
            String sql = "DELETE FROM " + property;
            dbs.changeDBSCon(con, sql);

            foreach (ModelDatalist datalist in liste) {
                sql = getinsertDatalist(property, datalist);                
                dbs.changeDBSCon(con, sql);
            }
        }

        public static String getupdateDatalist(String property, ModelDatalist datalist) {
            return "UPDATE " + property + " " +
                    "SET " +
                       "Label=" + datalist.LabelQuote 
                    + ";";
        }

        public static void updateDatalist(String property, ModelDatalist datalist) {
            String sql = getupdateDatalist(property, datalist);
            Dbs dbs = Dbs.getDbsInstance();
            dbs.changeDBS(MyRegistry.Databasefile, sql);
        }


        private static String getBasicDatas() {
            return "SELECT CAPTION, PLAYNAME, TITLE, BIRTHPLACE, BIRTHDAY, BODYHEIGHT, BODYWEIGHT, "+
                " GENDER, EYECOLOR, HAIRCOLOR, BODYCOLOR, EXPERIENCELEVEL, SPECIES, SOCIALSTATE, CULTURE, "+
                " PROFESSION, TRADITION,FAITH, ANIMALSOUL, ADVANTAGE, DISADVANTAGE "+
                " FROM "+ TBL_BASICDATAS+
                " ORDER BY caption";
        }

        public static List<ModelBasicDatas> getItemsFromBasicDatas() {
            List<ModelBasicDatas> liste = new List<ModelBasicDatas>();
            String sql = getBasicDatas();
            Dbs dbs = Dbs.getDbsInstance();
            DataTable dt = dbs.selectDBS(MyRegistry.Databasefile, sql);

            ModelBasicDatas basData;
            foreach (System.Data.DataRow row in dt.Rows) {
                basData = new ModelBasicDatas();
                basData.Caption = (String)row.ItemArray[0];
                basData.Playname = (String)row.ItemArray[1];
                basData.Title = (String)row.ItemArray[2];
                basData.Birthplace = (String)row.ItemArray[3];
                basData.Birthday = (String)row.ItemArray[4];
                basData.Bodyheight = (int)row.ItemArray[5];
                basData.Bodyweight = (decimal)row.ItemArray[6];
                basData.Gender = (String)row.ItemArray[7];
                basData.Eyecolor = (String)row.ItemArray[8];
                basData.Haircolor = (String)row.ItemArray[9];
                basData.Bodycolor = (String)row.ItemArray[10];
                basData.Experiencelevel = (String)row.ItemArray[11];
                basData.Species = (String)row.ItemArray[12];
                basData.Socialstate = (String)row.ItemArray[13];
                basData.Culture = (String)row.ItemArray[14];
                basData.Profession = (String)row.ItemArray[15];
                basData.Tradition = (String)row.ItemArray[16];
                basData.Faith = (String)row.ItemArray[17];
                basData.Animalsoul = (String)row.ItemArray[18];
                basData.Advantage = (String)row.ItemArray[19];
                basData.Disadvantage = (String)row.ItemArray[20];

                liste.Add(basData);
            }
            return liste;
        }


        public static String getinsertBasicData(ModelBasicDatas basdata) {
            return "INSERT INTO " + TBL_BASICDATAS + " (CAPTION, PLAYNAME, TITLE, BIRTHPLACE, BIRTHDAY, BODYHEIGHT, BODYWEIGHT, " +
                " GENDER, EYECOLOR, HAIRCOLOR, BODYCOLOR, EXPERIENCELEVEL, SPECIES, SOCIALSTATE, CULTURE, " +
                " PROFESSION, TRADITION,FAITH, ANIMALSOUL, ADVANTAGE, DISADVANTAGE) " +

               " Values (" + 
                    basdata.CaptionQuote + ", "+
                    basdata.PlaynameQuote + ", " +
                    basdata.TitleQuote + ", " +
                    basdata.BirthplaceQuote + ", " +
                    basdata.BirthdayQuote + ", " +
                    basdata.Bodyheight.ToString("0") + ", " +
                    basdata.Bodyweight.ToString("0.0").Replace(",",".") + ", " +

                    basdata.GenderQuote + ", " +
                    basdata.EyecolorQuote + ", " +
                    basdata.HaircolorQuote + ", " +
                    basdata.BodycolorQuote + ", " +
                    basdata.ExperiencelevelQuote + ", " +
                    basdata.SpeciesQuote + ", " +
                    basdata.SocialstateQuote + ", " +
                    basdata.CultureQuote + ", " +

                    basdata.ProfessionQuote + ", " +
                    basdata.TraditionQuote + ", " +
                    basdata.FaithQuote + ", " +
                    basdata.AnimalsoulQuote + ", " +
                    basdata.AdvantageQuote + ", " +
                    basdata.DisadvantageQuote +
               ")";
        }


        public static void insertNewBasicDatas(List<ModelBasicDatas> liste) {
            Dbs dbs = Dbs.getDbsInstance();
            OleDbConnection con = dbs.getCon(MyRegistry.Databasefile);
            String sql = "DELETE FROM " + TBL_BASICDATAS;
            dbs.changeDBSCon(con, sql);

            foreach (ModelBasicDatas basdata in liste) {
                sql = getinsertBasicData(basdata);
                dbs.changeDBSCon(con, sql);
            }
        }



        // -------------------------------------------------------------------------

        private static String getBackground() {
            return "SELECT CAPTION, Story " +
                " FROM " + TBL_BACKGROUND +
                " ORDER BY caption";
        }

        public static List<ModelBackground> getItemsFromBackground() {
            List<ModelBackground> liste = new List<ModelBackground>();
            String sql = getBackground();
            Dbs dbs = Dbs.getDbsInstance();
            DataTable dt = dbs.selectDBS(MyRegistry.Databasefile, sql);

            ModelBackground bg;
            foreach (System.Data.DataRow row in dt.Rows) {
                bg = new ModelBackground();
                bg.Caption = (String)row.ItemArray[0];
                bg.Story = (String)row.ItemArray[1];

                liste.Add(bg);
            }
            return liste;
        }


        public static String getinsertBackground(ModelBackground basdata) {
            return "INSERT INTO " + TBL_BACKGROUND + " (CAPTION, STORY) " +

               " Values (" + 
                  basdata.CaptionQuote + ", " +
                  basdata.StoryQuote +
               ")";
        }


        public static void insertNewBackgrounds(List<ModelBackground> liste) {
            Dbs dbs = Dbs.getDbsInstance();
            OleDbConnection con = dbs.getCon(MyRegistry.Databasefile);
            String sql = "DELETE FROM " + TBL_BACKGROUND;
            dbs.changeDBSCon(con, sql);

            foreach (ModelBackground basdata in liste) {
                sql = getinsertBackground(basdata);
                dbs.changeDBSCon(con, sql);
            }
        }




    }
}
