﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace DSA.FensterAllgemein {
    /// <summary>
    /// Interaction logic for WReadInput.xaml
    /// </summary>
    public partial class WReadInput : Window {

        private String dbtable = "WReadInput";

        private bool retcode = false;


        public bool Retcode {
            get { return retcode; }
        }



        public String Input {
            get { return tInput.Text.Trim(); }
        }

        public WReadInput(Window owner, String labelTitel, String label, String text) {
            InitializeComponent();

            Basis.setWindowPositionFromRegistryWidthHeight(this, MyRegistry.C_REG_ADR + "\\position", "dialog" + dbtable);
            this.Owner = owner;  // Important, because CenterOwner           
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            this.labelTitel.Content = labelTitel;
            Title = labelTitel;
            tInput.Text = text;
            LInput.Content = label;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tInput.Focus();
            setFontsize();
        }
        private void setFontsize() {
            int fHeadersize = MyRegistry.FontSize+1;
            int fNormalsize = MyRegistry.FontSize;
            this.FontSize = fNormalsize;
            labelTitel.FontSize = fHeadersize;
        }

        private void tInput_GotFocus(Object sender, RoutedEventArgs e) {
            tInput.SelectAll();
        }


        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (tInput.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte einen Wert ein", "Hinweis");
                tInput.Focus();
                return;
            }
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                e.Handled = true;
                bnEsc_Click(sender, e);
            }
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, MyRegistry.C_REG_ADR + "\\position", "dialog" + dbtable);
        }

    }
}