﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;


// 1.  reference Assemblies  Framework: System.windows.Controls.Ribbon
// 2.  using System.Windows.Controls.Ribbon;
using System.Windows.Controls.Ribbon;

using OpenFileDialog = Microsoft.Win32.OpenFileDialog;
using System.IO;

using DSA.FensterAllgemein;
using DSA.DBS_Klassen;
using DSA.ViewsDialog;
using DSA.Models;
using Microsoft.Win32;
using DSA.UserControls;

namespace DSA {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : RibbonWindow, IUserControls {


        private String dbtable = "MainWindowDSA";

        private ModelProject project = new ModelProject();

        private MyTreeNode usercontrolNode = null;

        public MainWindow() {
            InitializeComponent();
        }

        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            setLastProjects();
            
                CommandBindings.Add(new CommandBinding(MyCommands.ConvertProject, ConvertProjectExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.DlGender, DlGenderExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlEyecolor, DlEyecolorExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlColorhair, DlColorhairExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlBodycolor, DlBodycolorExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlExperienceLevel, DlExperienceLevelExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlSpecies, DlSpeciesExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.DlSocialstate, DlSocialstateExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlEyecolor, DlEyecolorExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlCulture, DlCultureExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlProfession, DlProfessionExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Dltradition, DltraditionExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlFaith, DlFaithExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlAnimalsoul, DlAnimalsoulExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlAdvantage, DlAdvantageExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.DlDisadvantage, DlDisadvantageExecuted, CheckCanExecuted));

            Basis.setWindowPositionFromRegistry(this, MyRegistry.C_REG_ADR + "\\position", dbtable);
            setFontsize();
        }

        private void setFontsize() {
            Ribbon.FontSize = MyRegistry.FontSize;
            cbLastProject.FontSize = MyRegistry.FontSize+1;
            lbProjectpath1.FontSize = MyRegistry.FontSize;
            lbProjectpath2.FontSize = MyRegistry.FontSize;
            this.FontSize = MyRegistry.FontSize;
        }


        private void bnFont_Click(Object sender, RoutedEventArgs e) {
            bnFont08.IsChecked = false;
            bnFont09.IsChecked = false;
            bnFont10.IsChecked = false;
            bnFont11.IsChecked = false;
            bnFont12.IsChecked = false;
            bnFont13.IsChecked = false;
            bnFont14.IsChecked = false;
            bnFont15.IsChecked = false;
            bnFont16.IsChecked = false;
            bnFont17.IsChecked = false;
            bnFont18.IsChecked = false;
            bnFont19.IsChecked = false;
            bnFont20.IsChecked = false;
            bnFont21.IsChecked = false;
            bnFont22.IsChecked = false;
            bnFont23.IsChecked = false;
            bnFont24.IsChecked = false;
            bnFont25.IsChecked = false;
            bnFont26.IsChecked = false;
            bnFont27.IsChecked = false;
            bnFont28.IsChecked = false;
            RibbonCheckBox bn = (RibbonCheckBox)sender;
            bn.IsChecked = true;
            int fontsize = 0;
            if (int.TryParse((String)bn.Tag, out fontsize)) {
                MyRegistry.FontSize = fontsize;
                setFontsize();
            }
        }


        private void setLastProjects() {
            cbLastProject.Items.Clear();
            if (MyRegistry.listeLastProjects.Count > 0) {
                foreach (LastProject lp in MyRegistry.listeLastProjects) {
                    cbLastProject.Items.Add(lp);
                }
                cbLastProject.SelectedIndex = 0;
            }
            else {
                bnOpenLastProject.IsEnabled = false;
            }
        }

        private void CheckCanExecuted(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = MyRegistry.Databasefile != null;
        }


        private void cbLastProject_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
            if (cbLastProject.SelectedIndex >= 0) {
                LastProject lp = (LastProject)cbLastProject.SelectedItem;
                cbLastProject.ToolTip = "Open a project: (" + lp.Filename + ", " + lp.Fullfilename + ")";
            }
        }

        private void bnNewProject_Click(Object sender, RoutedEventArgs e) {
            //WCharakter cha = new WCharakter(this);
            //cha.ShowDialog();
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "DSA Datei (*.dsa)|*.dsa|Alle Dateien (*.*)|*.*";
            saveFileDialog.FilterIndex = 1;// zählt von 1 !
            saveFileDialog.DefaultExt = ".dsa";
            saveFileDialog.InitialDirectory = System.Environment.CurrentDirectory;
            saveFileDialog.RestoreDirectory = true;
            if (saveFileDialog.ShowDialog() == true) {
                string filename = saveFileDialog.FileName.ToString();
                LastProject lp = new LastProject(saveFileDialog.FileName);
                MyRegistry.insertLastKataster(lp);
                setLastProjects();

                createDSAFile(filename);
                openDSAFile(filename);
            }
        }

        private void createDSAFile(String filename) {
            if (!AccessDB.createAccessDatei(filename)) {
                Basis.ErrorMsg("Die SDA-Datei konnte nicht angelegt werden\r\n"+filename, "Fehler");
                return;
            }

            String sqlFilename = Basis.getProgPath() + "dsa_sql.txt";
            String sql = "";
            if (File.Exists(sqlFilename)) {
                sql = File.ReadAllText(sqlFilename, Encoding.GetEncoding("ISO-8859-1"));
                AccessDB.insertAccessTables(filename, sql);
            }
            else {
                Basis.ErrorMsg("Die SQL-AccessDatei (dsa_sql.txt) ist nicht vorhanden", "Fehler");                
            }
        }

        private void bnOpenLastProject_Click(Object sender, RoutedEventArgs e) {
            if (cbLastProject.SelectedIndex >= 0) {
                LastProject lp = (LastProject)cbLastProject.SelectedItem;
                openDSAFile(lp.Fullfilename);
            }
        }

        private void bnOpenProject_Click(Object sender, RoutedEventArgs e) {
            Microsoft.Win32.OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "DSA files(*.dsa) | *.dsa";
            openFileDialog.InitialDirectory = Environment.CurrentDirectory;
            if (openFileDialog.ShowDialog() == true) {
                openDSAFile(openFileDialog.FileName);
                LastProject lp = new LastProject(openFileDialog.FileName);
                MyRegistry.insertLastKataster(lp);
                setLastProjects();
            }
        }

        private void openDSAFile(String filename) {
            MyRegistry.Databasefile = filename;
            lbProjectpath2.Content = filename;
            project.readDatas();
            setTree();
        }

        private TreeViewItem insertNode1(TreeViewItem parent, MyTreeNode myNode) {
            TreeViewItem treeitem = new TreeViewItem();
            treeitem.Header = myNode.Caption;
            treeitem.Tag = null;
            parent.Items.Add(treeitem);
            return treeitem;
        }
        private TreeViewItem insertNode2(TreeViewItem parent, MyTreeNode myNode) {
            TreeViewItem treeitem = new TreeViewItem();
            treeitem.Header = myNode.Caption;
            treeitem.Tag = myNode;
            parent.Items.Add(treeitem);
            return treeitem;
        }
        private void setTree() {
            TreeViewItem root;
            tree.Items.Clear();
            root = new TreeViewItem();
            root.Header = "root";
            root.Foreground = Brushes.Red;
            root.IsExpanded = true;
            tree.Items.Add(root);

            MyTreeNode node1 = new MyTreeNode("Grundlagen");
            TreeViewItem node = insertNode1(root, node1);

            List<ModelBasicDatas> basicListe = project.basicListe;
            foreach(ModelBasicDatas basisData in basicListe) {
                MyTreeNode node2 = new MyTreeNode(basisData.Caption);
                node2.obj = basisData;
                insertNode2(node, node2);
            }

            node1 = new MyTreeNode("Hintergrundgeschichte");
            node = insertNode1(root, node1);
            List<ModelBackground> bgListe = project.backgroundListe;
            foreach (ModelBackground bg in bgListe) {
                MyTreeNode node2 = new MyTreeNode(bg.Caption);
                node2.obj = bg;
                insertNode2(node, node2);
            }



            node1 = new MyTreeNode("Attribute");
            insertNode1(root, node1);

            node1 = new MyTreeNode("Vorteile");
            insertNode1(root, node1);

            node1 = new MyTreeNode("Nachteile");
            insertNode1(root, node1);
            node1 = new MyTreeNode("Talente");
            insertNode1(root, node1);

        }
        private void tree_SelectedItemChanged(Object sender, RoutedPropertyChangedEventArgs<Object> e) {
            TreeViewItem treeitem = (TreeViewItem) tree.SelectedItem;
            if (treeitem != null  && treeitem.Tag != null) {
                MyTreeNode myNode = (MyTreeNode)treeitem.Tag;

                if (myNode.obj is ModelBasicDatas) {
                    usercontrolNode = myNode;
                    ModelBasicDatas basdata = (ModelBasicDatas)myNode.obj;
                    dockpanel.Children.Clear();
                    USBasicDatas usbasdata = new USBasicDatas(this, project, basdata);
                    dockpanel.Children.Add(usbasdata);
                    // labeldockpanel.Content = basdata.Caption;
                }
                else if (myNode.obj is ModelBackground) {
                    usercontrolNode = myNode;
                    ModelBackground bg = (ModelBackground)myNode.obj;
                    dockpanel.Children.Clear();
                    USBackground usbg = new USBackground(this, project, bg);
                    dockpanel.Children.Add(usbg);
                }
                else {
                    dockpanel.Children.Clear();
                    usercontrolNode = null;
                }
            }
            else {
                dockpanel.Children.Clear();
                usercontrolNode = null;
            }
        }



        private void ConvertProjectExecuted(Object sender, ExecutedRoutedEventArgs e) {
            USCreateScript usgamescript = new USCreateScript(this, project);
            dockpanel.Children.Clear();
            dockpanel.Children.Add(usgamescript);
        }


        public void clearDockPanel() {
            dockpanel.Children.Clear();
        }

        public void deleteAndclearDockPanel() {
            if (usercontrolNode.obj is ModelBasicDatas) {
                if (project.basicListe.Count > 1) {
                    project.basicListe.Remove((ModelBasicDatas)usercontrolNode.obj);
                    setTree();
                    project.saveBasicDatas2Database();
                }
                else {
                    Basis.ErrorMsg("The selected item can't be delete. The project must have one basicdata item!", "Message");
                }
            }
            else if (usercontrolNode.obj is ModelBackground) {
                if (project.backgroundListe.Count > 1) {
                    project.backgroundListe.Remove((ModelBackground)usercontrolNode.obj);
                    setTree();
                    project.saveBackground2Database();
                }
                else {
                    Basis.ErrorMsg("The selected item can't be delete. The project must have one background story!", "Message");
                }
            }
        }  // deleteAndclearDockPanel

        public void copyAndclearDockPanel() {
            if (usercontrolNode.obj is ModelBasicDatas) {
                ModelBasicDatas basdata = (ModelBasicDatas)usercontrolNode.obj;
                ModelBasicDatas basdata2 = new ModelBasicDatas(basdata);
                basdata2.Caption = basdata2.Caption + " Kopie";
                project.basicListe.Add( basdata2 );
                project.saveBasicDatas2Database();
                setTree();
            }
            else if (usercontrolNode.obj is ModelBackground) {
                ModelBackground bg = (ModelBackground)usercontrolNode.obj;
                ModelBackground bg2 = new ModelBackground(bg);
                bg2.Caption = bg2.Caption + " Kopie";
                project.backgroundListe.Add(bg2);
                project.saveBackground2Database();
                setTree();
            }
        }



        //
        private void editdatalist(String caption, String datatable) {
            List<ModelDatalist> liste = Dbs_QueriesExceute.getItemsFromDataList(datatable);
            WDatalistDialog dialog = new WDatalistDialog(this, caption, liste);
            dialog.ShowDialog();
            if (dialog.retcode) {
                Dbs_QueriesExceute.insertNewDatalist(datatable, liste);
                project.updateListen();                
            }
        }

        

        private void DlGenderExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Gender",Dbs_QueriesExceute.TBL_GENDER);
        }
        private void DlEyecolorExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Eye color", Dbs_QueriesExceute.TBL_EYECOLOR);
        }
        private void DlColorhairExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Color hair", Dbs_QueriesExceute.TBL_HAIRCOLOR);
        }
        private void DlBodycolorExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Body color", Dbs_QueriesExceute.TBL_BODYCOLOR);
        }
        private void DlExperienceLevelExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Level of experience", Dbs_QueriesExceute.TBL_EXPERIENCELEVEL);
        }

        private void DlSpeciesExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Species", Dbs_QueriesExceute.TBL_SPECIES);
        }


        private void DlSocialstateExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Social state", Dbs_QueriesExceute.TBL_SOCIALSTATE);
        }
        private void DlCultureExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Culture", Dbs_QueriesExceute.TBL_CULTURE);
        }
        private void DlProfessionExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Profession", Dbs_QueriesExceute.TBL_PROFESSION);
        }
        private void DltraditionExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Tradition", Dbs_QueriesExceute.TBL_TRADITION);
        }
        private void DlFaithExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Faith", Dbs_QueriesExceute.TBL_FAITH);
        }
        private void DlAnimalsoulExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Animal soul", Dbs_QueriesExceute.TBL_ANIMALSOUL);
        }
        private void DlAdvantageExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Advantage", Dbs_QueriesExceute.TBL_ADVANTAGE);
        }
        private void DlDisadvantageExecuted(Object sender, ExecutedRoutedEventArgs e) {
            editdatalist("Disadvantage", Dbs_QueriesExceute.TBL_DISADVANTAGE);
        }







        private void bnDBConsole_Click(Object sender, RoutedEventArgs e) {
            WDBConsole dialog = new WDBConsole(this);
            dialog.ShowDialog();
        }

        private void bnOptions_Click(Object sender, RoutedEventArgs e) {
            WOptions dialog = new WOptions(this);
            dialog.ShowDialog();
        }

        private void bnProgInfo_Click(Object sender, RoutedEventArgs e) {
            WProgInfo dialog = new WProgInfo(this);
            dialog.ShowDialog();
        }



        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, MyRegistry.C_REG_ADR + "\\position", dbtable);
        }

    }
}
