﻿using DSA.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System.IO;


namespace DSA {
    public class MyRegistry {
        public static string C_REG_ADR = "SOFTWARE\\DOSDALL\\DSA";

        private static String databasefile = null;
        public static String Databasefile {
            get {
                return databasefile;
            }
            set {
                if (File.Exists(value)) {
                    databasefile = value;
                }
            }
        }

        private static bool splitRegSplit = true;
        public static bool SplitRegSplit {
            get { return splitRegSplit; }
            set {
                splitRegSplit = value;
                Basis.WriteRegInt(MyRegistry.C_REG_ADR, "issplitRegSplit", 1);
                Basis.WriteRegBool(MyRegistry.C_REG_ADR, "splitRegSplit", splitRegSplit);
            }
        }

        private static int fontSize = 14;
        public static int FontSize {
            set {
                fontSize = value;
                Basis.WriteRegInt(MyRegistry.C_REG_ADR, "fontsize", fontSize);
            }
            get { return fontSize; }
        }



        public static List<LastProject> listeLastProjects = new List<LastProject>();
        public static string C_REG_DBFile = "DBFile";
        public static int C_REG_DBAnz = 10;

        public static void insertLastKataster(LastProject lp) {
            bool gefunden = false;
            LastProject lploop;
            int min = Math.Min(C_REG_DBAnz, listeLastProjects.Count);
            int gefundenindex = -1;
            for (int i = 0; i < min; i++) {
                lploop = listeLastProjects[i];
                if (lploop.Fullfilename.ToLower().Equals(lp.Fullfilename.ToLower())) {
                    gefundenindex = i;
                    gefunden = true;
                    break;
                }
            }
            if (gefunden) {
                listeLastProjects.RemoveAt(gefundenindex);  // remove funktioniert nicht, da 
                listeLastProjects.Insert(0, lp);
            }
            else {
                listeLastProjects.Insert(0, lp);
            }
            writeLastProjects();
        }  // insertLastKataster

        public static void writeLastProjects() {
            LastProject lp;
            int min = Math.Min(C_REG_DBAnz, listeLastProjects.Count);
            for (int i = 1; i <= min; i++) {
                lp = listeLastProjects[i - 1];
                Basis.WriteRegString(MyRegistry.C_REG_ADR, MyRegistry.C_REG_DBFile + i, lp.Fullfilename);
            }
            // restliche Eintraege löschen
            for (int i = min + 1; i <= C_REG_DBAnz; i++) {
                Basis.WriteRegString(MyRegistry.C_REG_ADR, MyRegistry.C_REG_DBFile + i, "");
            }
        }  // writeLastProjects


        public static void readLastProjects() {
            for (int i = 1; i <= C_REG_DBAnz; i++) {
                String filename = Basis.ReadRegString(MyRegistry.C_REG_ADR, MyRegistry.C_REG_DBFile + i);
                if (filename.Trim().Length > 0) {
                    if (File.Exists(filename)) {
                        listeLastProjects.Add(new LastProject(filename));
                    }
                } // if
            }// for
        }  // readLastProjects



        static MyRegistry() {

            readLastProjects();

            int issplitRegSplit = Basis.ReadRegInt(MyRegistry.C_REG_ADR, "issplitRegSplit");
            if (issplitRegSplit > 0) {
                splitRegSplit = Basis.ReadRegBool(MyRegistry.C_REG_ADR, "splitRegSplit");
            }

            int size = Basis.ReadRegInt(MyRegistry.C_REG_ADR, "fontsize");
            if (size > 5) {
                FontSize = size;
            }


        }


    }
}
