﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;


using DSA.Models;

namespace DSA.UserControls {
    /// <summary>
    /// Interaction logic for USBackground.xaml
    /// </summary>
    public partial class USBackground : UserControl {

        private ModelBackground bg = null;
        private ModelProject project = null;

        private IUserControls parent = null;

        public USBackground(IUserControls parent, ModelProject project, ModelBackground bg) {
            InitializeComponent();
            this.parent = parent;
            this.project = project;
            this.bg = bg;

            this.FontSize = MyRegistry.FontSize;
            labelcaption.FontSize = MyRegistry.FontSize + 1;

            setDatas();
            if (parent==null) {
                bnDelete.IsEnabled = false;
                bnCopy.IsEnabled = false;
                bnOk.IsEnabled = false;
                bnEsc.IsEnabled = false;
            }
        }

        private void setDatas() {
            tcaption.Text = bg.Caption;
            tstory.Text = bg.Story;
        }

        private void bnSave_Click(Object sender, RoutedEventArgs e) {
            bg.Caption = tcaption.Text.Trim();
            bg.Story = tstory.Text;
            project.saveBackground2Database();
            parent.clearDockPanel();
        }

        private void bnEsc_Click(Object sender, RoutedEventArgs e) {
            parent.clearDockPanel();
        }

        private void bnDelete_Click(Object sender, RoutedEventArgs e) {
            if (Basis.readNoYes("Do you really want to delete this item?", "delete story background")) {
                parent.deleteAndclearDockPanel();
            }
        }

        private void bnCopy_Click(Object sender, RoutedEventArgs e) {
            parent.copyAndclearDockPanel();
        }
    }
}
