﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using DSA.Models;
using System.Data;

namespace DSA.ViewsDialog {
    /// <summary>
    /// Interaction logic for WCharakter.xaml
    /// </summary>
    public partial class WCharakter : Window {

        private String dbtable = "WDBConsole";

        public WCharakter(Window owner) {
            InitializeComponent();
            this.Owner = owner;
        }



        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            Datalists lists = new Datalists();
            DataTables table = new DataTables();

            // Initialisierung Grunddaten
            {
                cb_geschlecht.ItemsSource = lists.geschlecht;
                cb_geschlecht.SelectedIndex = 0;

                cb_spezies.ItemsSource = lists.spezies;
                cb_spezies.SelectedIndex = 0;

                cb_augenfarbe.ItemsSource = lists.augenfarbe;
                cb_augenfarbe.SelectedIndex = 0;

                cb_haarfarbe.ItemsSource = lists.haarfarbe;
                cb_haarfarbe.SelectedIndex = 0;

                cb_hautfarbe.ItemsSource = lists.hautfarbe;
                cb_hautfarbe.SelectedIndex = 0;

                cb_erfahrung.ItemsSource = lists.erfahrungsgrad;
                cb_erfahrung.SelectedIndex = 0;

                cb_sozial.ItemsSource = lists.sozialstatus;
                cb_sozial.SelectedIndex = 0;

                cb_kultur.ItemsSource = lists.kultur;
                cb_kultur.SelectedIndex = 0;

                cb_profession.ItemsSource = lists.profession;
                cb_profession.SelectedIndex = 0;

                cb_tradition.ItemsSource = lists.tradition;
                cb_tradition.SelectedIndex = 0;

                cb_glaube.ItemsSource = lists.glaube;
                cb_glaube.SelectedIndex = 0;

                cb_seelentier.ItemsSource = lists.seelentier;
                cb_seelentier.SelectedIndex = 0;
            }
            //Vorteil
            {
                int aktvorteil = 0;
                int anzahl = lists.vorteil.Count;
                for (int i = 0; i < anzahl; i++) {
                    lb_all.Items.Add(lists.vorteil[i].toString());
                }
                lb_all.SelectedIndex = 0;
                // ausgabe der aktuellen genutzen Punkte
                tb_aktvorteil.Text = aktvorteil.ToString();
            }

            // Nachteil
            {
                int aktnachteil = 0;
                int nach_anzahl = lists.nachteil.Count;
                for (int i = 0; i < nach_anzahl; i++) {
                    lb_nach_all.Items.Add(lists.nachteil[i].toString());
                }
                lb_all.SelectedIndex = 0;
                // ausgabe der aktuellen genutzen Punkte
                tb_aktnachteil.Text = aktnachteil.ToString();
            }

            // Talente laden und formatieren
            {
                körperdt.ItemsSource = table.körpertalentgen().DefaultView;
                körperdt.CanUserAddRows = false;
                körperdt.Height = (table.körperrowcount() * 27) + 35;

                geselldt.ItemsSource = table.gesellschaftstalentgen().DefaultView;
                geselldt.CanUserAddRows = false;
                geselldt.Height = (table.gesellrowcount() * 27) + 35;

                naturdt.ItemsSource = table.naturtalentgen().DefaultView;
                naturdt.CanUserAddRows = false;
                naturdt.Height = (table.naturrowcount() * 27) + 35;

                wissendt.ItemsSource = table.wissenstalentgen().DefaultView;
                wissendt.CanUserAddRows = false;
                wissendt.Height = (table.wissensrowcount() * 27) + 35;

                handwerkdt.ItemsSource = table.handwerkstalentgen().DefaultView;
                handwerkdt.CanUserAddRows = false;
                handwerkdt.Height = (table.handwerkrowcount() * 27) + 35;
            }
            Basis.setWindowPositionFromRegistry(this, MyRegistry.C_REG_ADR + "\\position", dbtable);
            setFontsize();
        }

        private void setFontsize() {
            this.FontSize = MyRegistry.FontSize;
        }

        private void auswahlen_Click(object sender, RoutedEventArgs e) {
            Datalists lists = new Datalists();
            int index = 0;
            int aktvorteil = Convert.ToInt32(tb_aktvorteil.Text);
            index = lb_all.SelectedIndex;
            if ((aktvorteil + lists.vorteil[index].vorteilwert) <= 80) {
                lb_chosen.Items.Add(lists.vorteil[index].toString());
                aktvorteil += lists.vorteil[index].vorteilwert;
                tb_aktvorteil.Text = aktvorteil.ToString();
            }
            else {
                MessageBox.Show("Sie haben nicht genügend freie Punkte um " +
                    "diesen Vorteil auszuwählen oder diesen Vorteil bereits ausgewählt.");
            }
        }

        private void nach_auswahlen_Click(object sender, RoutedEventArgs e) {
            Datalists lists = new Datalists();
            int index = 0;
            int aktnachteil = Convert.ToInt32(tb_aktnachteil.Text);
            index = lb_nach_all.SelectedIndex;
            if ((aktnachteil + lists.nachteil[index].vorteilwert) <= 80) {
                lb_nach_chosen.Items.Add(lists.nachteil[index].toString());
                aktnachteil += lists.vorteil[index].vorteilwert;
                tb_aktnachteil.Text = aktnachteil.ToString();
            }
            else {
                MessageBox.Show("Sie haben nicht genügend freie Punkte um diesen Nachteil auszuwählen oder diesen Nachteil bereits ausgewählt.");
            }
        }

        private void speichern_Click(object sender, RoutedEventArgs e) {
            using (System.IO.StreamWriter sw = new System.IO.StreamWriter(name.Text + ".txt")) {
                //Grunddaten
                sw.WriteLine(name.Text);
                sw.WriteLine(geburtsort.Text);
                sw.WriteLine(geburtstag.Text);
                sw.WriteLine(titel.Text);
                sw.WriteLine(große.Text);
                sw.WriteLine(gewicht.Text);
                sw.WriteLine(cb_spezies.SelectedValue);
                sw.WriteLine(cb_geschlecht.SelectedValue);
                sw.WriteLine(cb_augenfarbe.SelectedValue);
                sw.WriteLine(cb_haarfarbe.SelectedValue);
                sw.WriteLine(cb_hautfarbe.SelectedValue);
                sw.WriteLine(cb_erfahrung.SelectedValue);
                sw.WriteLine(cb_sozial.SelectedValue);
                sw.WriteLine(cb_kultur.SelectedValue);
                sw.WriteLine(cb_profession.SelectedValue);
                sw.WriteLine(cb_tradition.SelectedValue);
                sw.WriteLine(cb_glaube.SelectedValue);
                sw.WriteLine(cb_seelentier.SelectedValue);
                //Hintergrundgeschichte
                int anzahl = tb_hintergrund.LineCount;
                if (anzahl == -1) {
                    anzahl = 0;
                }
                sw.WriteLine(anzahl);
                if (anzahl > 0) {
                    sw.WriteLine(tb_hintergrund.Text);
                }

                // Attribute
                sw.WriteLine(tb_mu.Text);
                sw.WriteLine(tb_kl.Text);
                sw.WriteLine(tb_in.Text);
                sw.WriteLine(tb_ch.Text);
                sw.WriteLine(tb_ff.Text);
                sw.WriteLine(tb_ge.Text);
                sw.WriteLine(tb_ko.Text);
                sw.WriteLine(tb_kk.Text);
                //Vorteile
                anzahl = lb_chosen.Items.Count;
                sw.WriteLine(anzahl);
                for (int i = 0; i < anzahl; i++) {
                    sw.WriteLine(lb_chosen.Items.GetItemAt(i));
                }
                //Nachteile
                anzahl = lb_nach_chosen.Items.Count;
                sw.WriteLine(anzahl);
                for (int i = 0; i < anzahl; i++) {
                    sw.WriteLine(lb_nach_chosen.Items.GetItemAt(i));
                }
                //Talente
                foreach (DataRowView row in körperdt.Items) {
                    sw.WriteLine(row.Row.ItemArray[6].ToString());
                }
                foreach (DataRowView row in geselldt.Items) {
                    sw.WriteLine(row.Row.ItemArray[6].ToString());
                }
                foreach (DataRowView row in naturdt.Items) {
                    sw.WriteLine(row.Row.ItemArray[6].ToString());
                }
                foreach (DataRowView row in wissendt.Items) {
                    sw.WriteLine(row.Row.ItemArray[6].ToString());
                }
                foreach (DataRowView row in handwerkdt.Items) {
                    sw.WriteLine(row.Row.ItemArray[6].ToString());
                }
                MessageBox.Show("Speichern war erfolgreich.");
            }
        }

        private void abwahlen_Click(object sender, RoutedEventArgs e) {
            Datalists lists = new Datalists();
            int index = 0;
            int aktvorteil = Convert.ToInt32(tb_aktvorteil.Text);
            if (aktvorteil > 0) {
                // Schleife endet bei gesuchtem Index
                while (!lb_chosen.SelectedItem.ToString().Equals(lists.vorteil[index].toString())) {
                    index++;
                }
                aktvorteil -= lists.vorteil[index].vorteilwert;
                tb_aktvorteil.Text = aktvorteil.ToString();
                lb_chosen.Items.RemoveAt(lb_chosen.SelectedIndex);
            }
            else {
                MessageBox.Show("Es gibt keine Vorteile die Sie abwählen können.");
            }
        }

        private void nach_abwahlen_Click(object sender, RoutedEventArgs e) {
            Datalists lists = new Datalists();
            int index = 0;
            int aktnachteil = Convert.ToInt32(tb_aktnachteil.Text);
            if (aktnachteil > 0) {
                // Schleife endet bei gesuchtem Index
                while (!lb_nach_chosen.SelectedItem.ToString().Equals(lists.nachteil[index].toString())) {
                    index++;
                }
                aktnachteil -= lists.nachteil[index].vorteilwert;
                tb_aktnachteil.Text = aktnachteil.ToString();
                lb_nach_chosen.Items.RemoveAt(lb_nach_chosen.SelectedIndex);
            }
            else {
                MessageBox.Show("Es gibt keine Vorteile die Sie abwählen können.");
            }
        }


        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, MyRegistry.C_REG_ADR + "\\position", dbtable);
        }
    }
}
