﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using DSA.Models;
using DSA.FensterAllgemein;

namespace DSA.ViewsDialog {
    /// <summary>
    /// Interaction logic for WDatalistDialog.xaml
    /// </summary>
    public partial class WDatalistDialog : Window {

        private String dbtable = "WDatalistDialog";

        private List<ModelDatalist> liste = null;
        private String caption = "";

        public bool retcode = false;

        public WDatalistDialog(Window owner, String caption,  List<ModelDatalist> liste) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            this.liste = liste;
            this.caption = caption;
            labelTitel.Content = "Edit a new datalist-items (" + caption + ")";
            Title = "Edit a datalist-items (" + caption + ")";
        }

        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            listbox.ItemsSource = liste;
            Basis.setWindowPositionFromRegistry(this, MyRegistry.C_REG_ADR + "\\position", dbtable);
            setFontsize();
        }


        private void setFontsize() {
            this.FontSize = MyRegistry.FontSize;
            labelTitel.FontSize = MyRegistry.FontSize+1;
        }

        private void listbox_MouseDoubleClick(Object sender, MouseButtonEventArgs e) {
            int index = listbox.SelectedIndex;
            if (index >= 0) {
                ModelDatalist datalist = liste[index];
                // public WReadInput(Window owner, String labelTitel, String label, String text) {
                WReadInput dialog = new WReadInput(this, "Edit a item of the list " + caption, "Edit", datalist.Label);
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    datalist.Label = dialog.Input;
                    listbox.ItemsSource = null;
                    listbox.ItemsSource = liste;
                }
            }
        }

        private void bnAdd_Click(Object sender, RoutedEventArgs e) {
            WReadInput dialog = new WReadInput(this, "Insert a new item of the list " + caption, "Edit", "");
            dialog.ShowDialog();
            if (dialog.Retcode) {
                ModelDatalist datalist = new ModelDatalist(dialog.Input);
                liste.Add(datalist);
                listbox.ItemsSource = null;
                listbox.ItemsSource = liste;
            }
        }

        private void bnTop_Click(Object sender, RoutedEventArgs e) {
            int index = listbox.SelectedIndex;
            if (index>0) {
                ModelDatalist datalist = liste[index];
                liste.RemoveAt(index);
                liste.Insert(index - 1, datalist);
                listbox.ItemsSource = null;
                listbox.ItemsSource = liste;
                listbox.SelectedIndex = index - 1;
            }
        }

        private void bnDown_Click(Object sender, RoutedEventArgs e) {
            int index = listbox.SelectedIndex;
            if (index < liste.Count-1) {
                ModelDatalist datalist = liste[index];
                liste.RemoveAt(index);
                liste.Insert(index+1, datalist);
                listbox.ItemsSource = null;
                listbox.ItemsSource = liste;
                listbox.SelectedIndex = index + 1;
            }
        }

        private void bnDelete_Click(Object sender, RoutedEventArgs e) {
            int index = listbox.SelectedIndex;
            if (index >= 0) {
                liste.RemoveAt(index);
                listbox.ItemsSource = null;
                listbox.ItemsSource = liste;
            }
        }

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, MyRegistry.C_REG_ADR + "\\position", dbtable);
        }

        private void bnOk_Click(Object sender, RoutedEventArgs e) {
            retcode = true;
            Close();
        }

        private void bnCancel_Click(Object sender, RoutedEventArgs e) {
            Close();
        }

        

        private void Window_KeyDown(Object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                e.Handled = true;
                bnCancel_Click(sender, e);
            }
        }
    }
}
